#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "list.h"
#include "mem.h"

extern char *file_name;
extern int input_line;

struct header {
	u_char *key;
	char *pos;
	u_char *forms;
};

struct node {
	RAD_LIST *header;
	RAD_LIST *descr;
};

enum descr_type {
	descr_topic,
	descr_meaning,
	descr_antonym,
	descr_xref
};

struct descr {
	enum descr_type type;
	u_char *value;
};

struct xref {
	unsigned long index;
	u_char *value;
};

void open_input(char *name);
int sql_query(char *fmt, ...);
int sql_query_n(unsigned long *pret, char *fmt, ...);

extern char *sql_database;
extern char *sql_host;
extern int sql_port;
extern char *sql_password;
extern char *sql_user;
extern int debug;

